#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t, n, k;
    cin >> t >> n >> k;
    int a[n+1];
    for (int i = 1; i <= n; ++i)    cin >> a[i];
    int p = 0;
    sort(a+1, a+n+1);
    for (int i = 1; i <= n; ++i) {
        if (p <= a[i])
            p++;
        else
            p--;
    }
    if (p == k) {
        cout << "DA\n";
        for (int i = 1; i <= n; ++i)    cout << a[i] << ' ';
        cout << '\n';
    }
    else {
        cout << "NE\n";

    }
    return 0;
}